import 'package:flutter/cupertino.dart';
import 'package:get/get.dart';

class RxModel<T> extends Rx<T> {
  final bool isAutoStart;
  Future<T> Function() source;

  RxModel({
    required this.source,
    required T defaultValue,
    this.isAutoStart = true,
  }) : super(defaultValue) {
    if (isAutoStart) {
      fetch();
    }
  }

  Future fetch() async {
    await source().then((data) {
      WidgetsBinding.instance?.addPostFrameCallback((timeStamp) {
        this.value = data;
      });
      return data;
    });
  }
}
